package oracle.model.freight;

public enum CustomerCode {
    PLATINUM(20D),
    GOLD(10D),
    SILVER(5D),
    BRONZE(2D),
    OTHER(0D);

    Double factor;

    private CustomerCode(Double factor) {
        this.factor = factor;
    }

    public Double factor() {
        return this.factor;
    }

    public Double calculateDiscount(Double originalPrice) {
        return (originalPrice * factor) / 100;
    }
}
