package oracle.model.freightejb;

import javax.ejb.Stateless;

import javax.jws.WebService;

import javax.xml.ws.BindingType;
import javax.xml.ws.soap.SOAPBinding;

import oracle.model.freight.BatchOrder;
import oracle.model.freight.CustomerCode;
import oracle.model.freight.FreightDestination;

@Stateless(name = "CalculateFreight",
           mappedName = "WSDataControlApp-EJBModel-CalculateFreight")
@WebService(name = "CalculateFreightBeanService", portName = "CalculateFreightBeanServiceSoap12HttpPort")
@BindingType(SOAPBinding.SOAP12HTTP_BINDING)
public class CalculateFreightBean {
    public CalculateFreightBean() {
    }

    private static final Double BASE_COST = 10D;

    public Double calculateFreightCost(BatchOrder order,
                                       FreightDestination destination,
                                       CustomerCode customer) {
        Double totalCost =
            BASE_COST + order.getOrderedQuantity() * destination.factor();
        Double discount = customer.calculateDiscount(totalCost);
        return totalCost - discount;
    }
}
